質問をすることでしか得られない、回答やアドバイスがある。

15分調べてもわからないことは、質問しよう!

ただいまの
回答率

90.34%

  • Swift

    9428questions

    Swiftは、アップルのiOSおよびOS Xのためのプログラミング言語で、Objective-CやObjective-C++と共存することが意図されています

  • Xcode

    5303questions

    Xcodeはソフトウェア開発のための、Appleの統合開発環境です。Mac OSXに付随するかたちで配布されています。

久しぶりにXCodeを起動してアプリをビルドしようとしたらUnsupported Swift Versionと表示される

解決済

回答 1

投稿

  • 評価
  • クリップ 1
  • VIEW 239

bizkit.kit

score 28

昨年(2018年)の12月20日にアプリをアップデートしてリリースしました。

その後、忙しくてアプリをアップデートできなかったのですが、今日(2019年4月15日)久しぶりにXCodeを開いて見ると
Unsupproted Swift Versionという警告ダイアログが表示されました。

イメージ説明

前回のアプリのアップデートから今日までXCodeは開かなかったのですが、XCodeのアップデートは常に実行していました。

アプリは2年くらい前から作っているものなので、確かに古いバージョンのSwiftのコードが含まれています。
メッセージを読むと、このバージョンのXCodeではマイグレーションもビルドも出来ないから一つ古いバージョンのXCodeを入れてマイグレートしなさい、とありますので、自分で書いた部分についてはなんとかやってみようかなと思うのですが、
自分で書いていない、cocoapodで導入しているライブラリについてはどうなるのでしょうか?

いくつかライブラリを使用していますが、中には更新がすでにだいぶ前に止まってしまっているものもあります。
試しにビルドしてみると、その導入しているライブラリからエラーが出てビルドできませんでした。

一般的に、このような場合はどうするものなのでしょうか。

以上、よろしくお願いいたします。

  • 気になる質問をクリップする

    クリップした質問は、後からいつでもマイページで確認できます。

    またクリップした質問に回答があった際、通知やメールを受け取ることができます。

    クリップを取り消します

  • 良い質問の評価を上げる

    以下のような質問は評価を上げましょう

    • 質問内容が明確
    • 自分も答えを知りたい
    • 質問者以外のユーザにも役立つ

    評価が高い質問は、TOPページの「注目」タブのフィードに表示されやすくなります。

    質問の評価を上げたことを取り消します

  • 評価を下げられる数の上限に達しました

    評価を下げることができません

    • 1日5回まで評価を下げられます
    • 1日に1ユーザに対して2回まで評価を下げられます

    質問の評価を下げる

    teratailでは下記のような質問を「具体的に困っていることがない質問」、「サイトポリシーに違反する質問」と定義し、推奨していません。

    • プログラミングに関係のない質問
    • やってほしいことだけを記載した丸投げの質問
    • 問題・課題が含まれていない質問
    • 意図的に内容が抹消された質問
    • 広告と受け取られるような投稿

    評価が下がると、TOPページの「アクティブ」「注目」タブのフィードに表示されにくくなります。

    質問の評価を下げたことを取り消します

    この機能は開放されていません

    評価を下げる条件を満たしてません

    評価を下げる理由を選択してください

    詳細な説明はこちら

    上記に当てはまらず、質問内容が明確になっていない質問には「情報の追加・修正依頼」機能からコメントをしてください。

    質問の評価を下げる機能の利用条件

    この機能を利用するためには、以下の事項を行う必要があります。

回答 1

checkベストアンサー

+2

Migration処理について

XCodeのマイグレーション処理はあまり賢い方ではないので、とりあえず試してみてダメだと思ったら、全て手動でマイグレーションしたほうが良いです。

自分で書いていないCocoaPodsのライブラリについて

更新が止まっていたら代替となるライブラリを探すか、自分で開発するしかありません。
それはiOSに限らずライブラリを使用する際のリスクです。

Appleの審査について

Appleは定期的に審査で必要なSDKのバージョンをあげてきます。

数年間メンテナンスをしなかった場合、急に更新が必要な時があっても、審査を通すためにiOS SDKのバージョンをあげなくてはならず、その際にSwiftのバージョンも上げる必要が発生します。
継続的にXCodeでビルドして動作できるか確認したほうが良いです。

投稿

  • 回答の評価を上げる

    以下のような回答は評価を上げましょう

    • 正しい回答
    • わかりやすい回答
    • ためになる回答

    評価が高い回答ほどページの上位に表示されます。

  • 回答の評価を下げる

    下記のような回答は推奨されていません。

    • 間違っている回答
    • 質問の回答になっていない投稿
    • スパムや攻撃的な表現を用いた投稿

    評価を下げる際はその理由を明確に伝え、適切な回答に修正してもらいましょう。

  • 2019/04/17 08:27

    回答ありがとうございます。

    以前からSwiftのバージョンに関する警告はちょいちょい出ていたのですが見て見ぬ振りをしていました。。。とりあえずXCode10.1をダウンロードしてからマイグレーションを試して、ダメそうなら手動でやってみようと思います。


    ライブラリについてはやはりそうなのですね。4~5年前までJavaのエンジニアだったのですが、Javaのライブラリはコンパイル済みのものを配布することが多かったので、多少古くても使えたのですが(今はどうかわかりませんが)、なんとなくSwiftでも使えないことはないのかなと勝手に思っていました。詳しくはわかりませんが、cocoapodはソースを落としてきて自分でビルドするような仕組み?っぽいのでちょっと違いますね。
    少し本筋とそれますが、ライブラリのソースを自己責任で勝手にSwiftの新しいバージョンに対応させるというのはアリなのでしょうか。

    キャンセル

  • 2019/04/17 23:58

    OSSなどはメンテナンスされないものを自分で対応するということは良くあることですがライセンスに注意ください。
    また、アップストリームファーストと言って、使っているOSSライブラリの不足している機能等を自らコントリビュートしたうえで、自社製品に組み込むという考え方もあります。

    キャンセル

  • 2019/04/19 13:38

    ありがとうございます。私にはそこまでの技術力はありませんが。。。参考になりました😅

    キャンセル

15分調べてもわからないことは、teratailで質問しよう!

  • ただいまの回答率 90.34%
  • 質問をまとめることで、思考を整理して素早く解決
  • テンプレート機能で、簡単に質問をまとめられる

同じタグがついた質問を見る

  • Swift

    9428questions

    Swiftは、アップルのiOSおよびOS Xのためのプログラミング言語で、Objective-CやObjective-C++と共存することが意図されています

  • Xcode

    5303questions

    Xcodeはソフトウェア開発のための、Appleの統合開発環境です。Mac OSXに付随するかたちで配布されています。